diff --git a/stdlib/Makefile b/stdlib/Makefile
index 92ceca7..1179400 100644
--- a/stdlib/Makefile
+++ b/stdlib/Makefile
@@ -73,7 +73,8 @@ tests		:= tst-strtol tst-strtod testmb testrand testsort testdiv   \
 		   tst-makecontext2 tst-strtod6 tst-unsetenv1		    \
 		   tst-makecontext3 bug-getcontext bug-fmtmsg1		    \
 		   tst-secure-getenv tst-strtod-overflow tst-strtod-round   \
-		   tst-tininess tst-strtod-underflow tst-tls-atexit
+		   tst-tininess tst-strtod-underflow tst-tls-atexit	    \
+		   tst-setcontext2
 tests-static	:= tst-secure-getenv
 
 modules-names	= tst-tls-atexit-lib
@@ -157,3 +158,9 @@ tst-tls-atexit-lib.so-no-z-defs = yes
 
 $(objpfx)tst-tls-atexit: $(shared-thread-library) $(libdl)
 $(objpfx)tst-tls-atexit.out: $(objpfx)tst-tls-atexit-lib.so
+
+$(objpfx)tst-setcontext2.out: tst-setcontext2.sh $(objpfx)tst-setcontext2
+	$(SHELL) $< $(common-objpfx) '$(test-program-prefix-before-env)' \
+		 '$(run-program-env)' '$(test-program-prefix-after-env)' \
+		 $(common-objpfx)stdlib/; \
+	$(evaluate-test)
diff --git a/stdlib/tst-setcontext2.c b/stdlib/tst-setcontext2.c
new file mode 100644
index 0000000..1ead75d
--- /dev/null
+++ b/stdlib/tst-setcontext2.c
@@ -0,0 +1,137 @@
+/* Bug 18125: Verify setcontext calls exit() and not _exit().
+   Copyright (C) 2015 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include <errno.h>
+#include <signal.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <ucontext.h>
+#include <unistd.h>
+#include <limits.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+
+static ucontext_t ctx;
+#ifndef PATH_MAX
+# define PATH_MAX 4096
+#endif
+char filename[PATH_MAX];
+
+/* It is intended that this function does nothing.  */
+static void
+cf (void)
+{
+  printf ("called context function\n");
+  return;
+}
+
+static void
+exit_called (void)
+{
+  int fd;
+  ssize_t res;
+  char buf[] = "Called exit function\n";
+  fd = open (filename, O_WRONLY | O_CREAT, S_IRUSR | S_IWUSR);
+  if (fd == -1)
+    {
+      printf ("FAIL: Unable to create test file %s\n", filename);
+      exit (1);
+    }
+  res = write (fd, buf, sizeof (buf));
+  if (res != sizeof (buf))
+    {
+      printf ("FAIL: Expected to write test file in one write call.\n");
+      exit (1);
+    }
+  printf ("PASS: %s", buf);
+  res = close (fd);
+  if (res == -1)
+    {
+      printf ("FAIL: Failed to close test file.\n");
+      exit (1);
+    }
+  return;
+}
+
+/* The test expects a filename given by the wrapper calling script.
+   The test then registers an atexit handler that will create the
+   file to indicate that the atexit handler ran. Then the test
+   creates a context, modifies it with makecontext, and sets it.
+   The context has only a single context which then must exit.
+   If it incorrectly exits via _exit then the atexit handler is
+   not run, the file is not created, and the wrapper detects this
+   and fails the test.  This test cannot be done using an _exit
+   interposer since setcontext avoids the PLT and calls _exit
+   directly.  */
+static int
+do_test (int argc, char **argv)
+{
+  int ret;
+  char st1[32768];
+  ucontext_t tempctx = ctx;
+
+  if (argc < 2)
+    {
+      printf ("FAIL: Test missing filename argument.\n");
+      exit (1);
+    }
+
+  strcpy (filename, argv[1]);
+
+  atexit (exit_called);
+
+  puts ("making contexts");
+  if (getcontext (&ctx) != 0)
+    {
+      if (errno == ENOSYS)
+	{
+	  /* Exit with 77 to mark the test as UNSUPPORTED.  */
+	  printf ("UNSUPPORTED: getcontext not implemented.\n");
+	  exit (77);
+	}
+
+      printf ("FAIL: getcontext failed.\n");
+      exit (1);
+    }
+
+  ctx.uc_stack.ss_sp = st1;
+  ctx.uc_stack.ss_size = sizeof (st1);
+  ctx.uc_link = 0;
+  makecontext (&ctx, (void (*) (void)) cf, 0);
+
+  /* Without this check, a stub makecontext can make us spin forever.  */
+  if (memcmp (&tempctx, &ctx, sizeof ctx) == 0)
+    {
+      puts ("UNSUPPORTED: makecontext was a no-op, presuming not implemented");
+      return 77;
+    }
+
+  if ((ret = setcontext (&ctx)) != 0)
+    {
+      printf ("FAIL: setcontext returned with %d and errno of %d.\n", ret, errno);
+      exit (1);
+    }
+
+  printf ("FAIL: Impossibly returned to main.\n");
+  return 1;
+}
+
+#define TEST_FUNCTION do_test (argc, argv)
+#include "../test-skeleton.c"
diff --git a/stdlib/tst-setcontext2.sh b/stdlib/tst-setcontext2.sh
new file mode 100644
index 0000000..c82e4ba
--- /dev/null
+++ b/stdlib/tst-setcontext2.sh
@@ -0,0 +1,55 @@
+#! /bin/bash
+# Bug 18125: Test the exit functionality of setcontext().
+# Copyright (C) 2015 Free Software Foundation, Inc.
+# This file is part of the GNU C Library.
+
+# The GNU C Library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2.1 of the License, or (at your option) any later version.
+
+# The GNU C Library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Lesser General Public License for more details.
+
+# You should have received a copy of the GNU Lesser General Public
+# License along with the GNU C Library; if not, see
+# <http://www.gnu.org/licenses/>.
+
+set -e
+
+common_objpfx=$1
+test_program_prefix_before_env=$2
+run_program_env=$3
+test_program_prefix_after_env=$4
+objpfx=$5
+
+test_pre="${test_program_prefix_before_env} ${run_program_env}"
+test="${test_program_prefix_after_env} ${objpfx}tst-setcontext2"
+out=${objpfx}tst-setcontext2.out
+
+tempfiles=()
+cleanup() {
+    rm -f "${tempfiles[@]}"
+}
+trap cleanup 0
+
+tempfile=$(mktemp "tst-setcontext2.XXXXXXXXXX")
+tempfiles+=("$tempfile")
+
+# We want to run the test program and see if secontext called
+# exit() and wrote out the test file we specified.  If the
+# test exits with a non-zero status this will fail because we
+# are using `set -e`.
+$test_pre $test $tempfile
+
+# Look for resulting file.
+if [ -e "$tempfile" ]; then
+  echo "PASS: tst-setcontext2 ran exit() and created $tempfile"
+  cleanup
+  exit 0
+else
+  echo "FAIL: tst-setcontext2 did not create $tempfile"
+  exit 1
+fi
diff --git a/sysdeps/unix/sysv/linux/aarch64/setcontext.S b/sysdeps/unix/sysv/linux/aarch64/setcontext.S
index 6dd7836..ae67581 100644
--- a/sysdeps/unix/sysv/linux/aarch64/setcontext.S
+++ b/sysdeps/unix/sysv/linux/aarch64/setcontext.S
@@ -125,5 +125,5 @@ weak_alias (__setcontext, setcontext)
 ENTRY (__startcontext)
 	mov	x0, x19
 	cbnz	x0, __setcontext
-1:	b       HIDDEN_JUMPTARGET (_exit)
+1:	b       HIDDEN_JUMPTARGET (exit)
 END (__startcontext)
diff --git a/sysdeps/unix/sysv/linux/arm/setcontext.S b/sysdeps/unix/sysv/linux/arm/setcontext.S
index 5268e06..24c7294 100644
--- a/sysdeps/unix/sysv/linux/arm/setcontext.S
+++ b/sysdeps/unix/sysv/linux/arm/setcontext.S
@@ -91,7 +91,7 @@ ENTRY(__startcontext)
 	bne     PLTJMP(__setcontext)
 
 	@ New context was 0 - exit
-	b       PLTJMP(HIDDEN_JUMPTARGET(_exit))
+	b       PLTJMP(HIDDEN_JUMPTARGET(exit))
 END(__startcontext)
 
 #ifdef PIC
diff --git a/sysdeps/unix/sysv/linux/hppa/setcontext.S b/sysdeps/unix/sysv/linux/hppa/setcontext.S
index 7271410..abe87a9 100644
--- a/sysdeps/unix/sysv/linux/hppa/setcontext.S
+++ b/sysdeps/unix/sysv/linux/hppa/setcontext.S
@@ -18,6 +18,7 @@
    <http://www.gnu.org/licenses/>.  */
 
 #include <sysdep.h>
+#include <libc-symbols.h>
 
 #include "ucontext_i.h"
 
@@ -139,7 +140,7 @@ ENTRY(__setcontext)
 	nop
 
 	/* No further context available. Exit now.  */
-	bl	_exit, %r2
+	bl	HIDDEN_JUMPTARGET(exit), %r2
 	ldi	-1, %r26
 
 
diff --git a/sysdeps/unix/sysv/linux/nios2/setcontext.S b/sysdeps/unix/sysv/linux/nios2/setcontext.S
index 9a8dd87..f40b733 100644
--- a/sysdeps/unix/sysv/linux/nios2/setcontext.S
+++ b/sysdeps/unix/sysv/linux/nios2/setcontext.S
@@ -89,15 +89,15 @@ ENTRY(__startcontext)
 	mov	r4, r16
 	bne	r4, zero, __setcontext
 
-	/* If uc_link == zero, call _exit.  */
+	/* If uc_link == zero, call exit.  */
 #ifdef PIC
 	nextpc	r22
 1:	movhi	r8, %hiadj(_gp_got - 1b)
 	addi	r8, r8, %lo(_gp_got - 1b)
 	add	r22, r22, r8
-	ldw	r8, %call(HIDDEN_JUMPTARGET(_exit))(r22)
+	ldw	r8, %call(HIDDEN_JUMPTARGET(exit))(r22)
 	jmp	r8
 #else
-	jmpi	_exit
+	jmpi	exit
 #endif
 END(__startcontext)
